package com.lovecoding.jdbc.service;

import com.lovecoding.jdbc.dao.Book;
import com.lovecoding.jdbc.dao.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class UserBuyBookServiceImpl implements UserBuyBookService{

    /**
     * 买书 分为一下及步骤
     * 0 查库存
     * 1 扣库存
     * 2 扣用户余额
     * @param uid
     * @param bookid
     */

    @Autowired
    private Book book;
    @Autowired
    private User user;

    @Override
    //@Transactional
    public void buyBook(int uid, int bookid) {
        //查询书的价格
        int price = book.getBook(bookid);
        //扣减书的库存
        this.book.subBook(bookid);
        //扣减用户钱包
        user.balance( price, uid );
    }
}
